/*
 * Copyright © 2020-2022 Koherence, LLC (www.koherence.com).
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation with the addition of 
 * the following permission added to Section 15 as permitted in Section 7(a): 
 * FOR ANY PART OF THE COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY 
 * KOHERENCE, LLC, KOHERENCE, LLC DISCLAIMS THE WARRANTY OF NON INFRINGEMENT 
 * OF THIRD PARTY RIGHTS.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write 
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
 * Boston, MA 02110-1301 USA.
 *
 * You can contact Koherence, LLC at email address info@koherence.com
 */

#ifndef LIBENATSC3ESG_H
#define LIBENATSC3ESG_H

typedef struct _ENATSC3ESGSessionHandle_t *ENATSC3ESGSessionHandle_t;

typedef void (*ENATSC3ESGSessionServiceFragmentCallback)(
    struct timespec *pPacketTimeUTC, int32_t esgSet, uint32_t idOffset, 
    int32_t idLength, uint32_t version, uint32_t globalServiceIDOffset, 
    int32_t globalServiceIDLength, const char *pXML, int32_t xmlLength, 
    void *pUserData);

typedef void (*ENATSC3ESGSessionScheduleFragmentCallback)(
    struct timespec *pPacketTimeUTC, int32_t esgSet, uint32_t idOffset, 
    int32_t idLength, uint32_t version, uint32_t serviceIdReference, 
    int32_t serviceIdReferenceLength, const char *pXML, int32_t xmlLength, 
    void *pUserData);

typedef void (*ENATSC3ESGSessionContentFragmentCallback)(
    struct timespec *pPacketTimeUTC, int32_t esgSet, uint32_t idOffset, 
    int32_t idLength, uint32_t version, const char *pXML, int32_t xmlLength, 
    void *pUserData);

ENStatus
ENATSC3ESGSessionAllocate(ENATSC3ROUTESessionHandle_t hROUTESession,
    char *pDebugName, ENATSC3ESGSessionHandle_t *phSession);

ENStatus
ENATSC3ESGSessionFree(ENATSC3ESGSessionHandle_t hSession);

ENStatus
ENATSC3ESGSessionRegisterCallbacks(ENATSC3ESGSessionHandle_t hSession,
    ENATSC3ESGSessionServiceFragmentCallback ServiceFragmentCallback,
    ENATSC3ESGSessionScheduleFragmentCallback ScheduleFragmentCallback,
    ENATSC3ESGSessionContentFragmentCallback ContentFragmentCallback,
    void *pUserData);

ENStatus
ENATSC3ESGSessionUnregisterCallbacks(ENATSC3ESGSessionHandle_t hSession,
    ENATSC3ESGSessionServiceFragmentCallback ServiceFragmentCallback,
    ENATSC3ESGSessionScheduleFragmentCallback ScheduleFragmentCallback,
    ENATSC3ESGSessionContentFragmentCallback ContentFragmentCallback,
    void *pUserData);

ENStatus
ENATSC3ESGSessionSetVerbosity(ENATSC3ESGSessionHandle_t hSession,
    ENVerbosity verbosity);

#endif
