/*
 * Copyright © 2019 - 2022 Koherence, LLC (www.koherence.com).
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation with the addition of
 * the following permission added to Section 15 as permitted in Section 7(a):
 * FOR ANY PART OF THE COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY
 * KOHERENCE, LLC, KOHERENCE, LLC DISCLAIMS THE WARRANTY OF NON INFRINGEMENT
 * OF THIRD PARTY RIGHTS.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * You can contact Koherence, LLC at email address info@koherence.com
 */

#ifndef ENATSC3SSP_H
#define ENATSC3SSP_H

typedef struct _ENATSC3SSP *ENATSC3SSPHandle_t;

typedef ENStatus (*ENATSC3SSPLoadCertificatesCallback)(
    ENATSC3SSPHandle_t hSSP, STACK_OF(X509) *pCertificatesStack,
    void *pUserData);

ENStatus
ENATSC3SSPCreate(ENATSC3SSPLoadCertificatesCallback LoadCertificatesCallback, 
    void *pCallbackUserData, ENATSC3SSPHandle_t *phSSP); 

ENStatus
ENATSC3SSPDestroy(ENATSC3SSPHandle_t hSSP);

ENStatus
ENATSC3SSPVerifySignedMultitableSignature(ENATSC3SSPHandle_t hSSP,
    const uint8_t *pSignedMultitable, int32_t signedMultitableLen,
    int32_t fDontVerifySigningCertificate);
 
ENStatus
ENATSC3SSPVerifyAndLoadCertificationData(ENATSC3SSPHandle_t hSSP, char *pXML, 
    int32_t xmlLength, ATSC3LLSCDT_CertificationDataNode *pParsedCDT,
    struct timespec *pAbsMonoTimeout, int32_t fDontVerifySigningCertificate, 
    int32_t fIgnoreOCSPResponseExpired);

#endif
