/*
 * Copyright © 2018-2022 Koherence, LLC (www.koherence.com).
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation with the addition of
 * the following permission added to Section 15 as permitted in Section 7(a):
 * FOR ANY PART OF THE COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY
 * KOHERENCE, LLC, KOHERENCE, LLC DISCLAIMS THE WARRANTY OF NON INFRINGEMENT
 * OF THIRD PARTY RIGHTS.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * You can contact Koherence, LLC at email address info@koherence.com
 */

#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>
#include <arpa/inet.h>

#include "libenutils_defs.h"
#include "libenutils.h"

uint64_t
ENUtils_htonll(uint64_t x)
{
    uint64_t rval;

    if (htonl(1) == 1)
    {
        rval = x;
    }
    else
    {
        rval = (((uint64_t)htonl(x & 0xffffffff)) << 32) | htonl(x >> 32);
    }

    return rval;
}

uint64_t
ENUtils_ntohll(uint64_t x)
{
    uint64_t rval;

    if (ntohl(1) == 1)
    {
        rval = x;
    }
    else
    {
        rval = (((uint64_t)ntohl(x & 0xffffffff)) << 32) | ntohl(x >> 32);
    }

    return rval;
}

uint64_t
ENUtils_atoull(char *pString)
{
    uint64_t rval = 0;

    while (*pString)
    {
        rval *= 10;
        rval += *pString - '0';
        pString++;
    }

    return rval;
}
