/*
 * Copyright © 2018-2019 Koherence, LLC (www.koherence.com).
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation with the addition of
 * the following permission added to Section 15 as permitted in Section 7(a):
 * FOR ANY PART OF THE COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY
 * KOHERENCE, LLC, KOHERENCE, LLC DISCLAIMS THE WARRANTY OF NON INFRINGEMENT
 * OF THIRD PARTY RIGHTS.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * You can contact Koherence, LLC at email address info@koherence.com
 */

#ifndef LIBENUTILS_BASE64_H
#define LIBENUTILS_BASE64_H

#define ENUtils_Base64EncodedSize(x) (4 * ((x + 2) / 3))

// Note: This is the maximum decoded size. Due to padding the actual number of
// output bytes may be one or two less
#define ENUtils_Base64DecodedSize(x) ((x / 4) * 3)

void
ENUtils_Base64Encode(const uint8_t *pData, int32_t nData, char *pOut,
    int32_t *nOut);

int32_t
ENUtils_Base64Decode(const char *pData, int32_t nData, uint8_t *pOut,
    int32_t *nOut);

#endif
