/*
 * Copyright © 2018-2022 Koherence, LLC (www.koherence.com).
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation with the addition of
 * the following permission added to Section 15 as permitted in Section 7(a):
 * FOR ANY PART OF THE COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY
 * KOHERENCE, LLC, KOHERENCE, LLC DISCLAIMS THE WARRANTY OF NON INFRINGEMENT
 * OF THIRD PARTY RIGHTS.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * You can contact Koherence, LLC at email address info@koherence.com
 */

#ifndef LIBENUTILS_DEFS_VERBOSITY_H
#define LIBENUTILS_DEFS_VERBOSITY_H

typedef enum
{
    // Errors only
    ENVerbosity_Error = 0,

    // Warnings
    ENVerbosity_Warn = 5,

    // Some debug output
    ENVerbosity_Terse = 10,

    // Debug output for stream events, such as start/end of a period
    ENVerbosity_StreamEventTrace = 15,

    // Debug output that occurs regularly, such as on a per-segment basis
    ENVerbosity_ObjectTrace = 20,

    // Debug output that occurs regularly, such as on a per-packet basis
    ENVerbosity_PacketTrace = 25,

    // Extremely verbose output
    ENVerbosity_Pedantic = 30,
} ENVerbosity;

#endif
